/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the SalesforceControllerActionObjectRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SalesforceControllerActionObjectRequest{}

// SalesforceControllerActionObjectRequest struct for SalesforceControllerActionObjectRequest
type SalesforceControllerActionObjectRequest struct {
	OAuthId    *string `json:"oAuthId,omitempty"`
	Instance   *string `json:"instance,omitempty"`
	ApiVersion *string `json:"apiVersion,omitempty"`
}

// NewSalesforceControllerActionObjectRequest instantiates a new SalesforceControllerActionObjectRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSalesforceControllerActionObjectRequest() *SalesforceControllerActionObjectRequest {
	this := SalesforceControllerActionObjectRequest{}
	return &this
}

// NewSalesforceControllerActionObjectRequestWithDefaults instantiates a new SalesforceControllerActionObjectRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSalesforceControllerActionObjectRequestWithDefaults() *SalesforceControllerActionObjectRequest {
	this := SalesforceControllerActionObjectRequest{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *SalesforceControllerActionObjectRequest) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SalesforceControllerActionObjectRequest) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *SalesforceControllerActionObjectRequest) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *SalesforceControllerActionObjectRequest) SetOAuthId(v string) {
	o.OAuthId = &v
}

// GetInstance returns the Instance field value if set, zero value otherwise.
func (o *SalesforceControllerActionObjectRequest) GetInstance() string {
	if o == nil || IsNil(o.Instance) {
		var ret string
		return ret
	}
	return *o.Instance
}

// GetInstanceOk returns a tuple with the Instance field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SalesforceControllerActionObjectRequest) GetInstanceOk() (*string, bool) {
	if o == nil || IsNil(o.Instance) {
		return nil, false
	}
	return o.Instance, true
}

// HasInstance returns a boolean if a field has been set.
func (o *SalesforceControllerActionObjectRequest) HasInstance() bool {
	if o != nil && !IsNil(o.Instance) {
		return true
	}

	return false
}

// SetInstance gets a reference to the given string and assigns it to the Instance field.
func (o *SalesforceControllerActionObjectRequest) SetInstance(v string) {
	o.Instance = &v
}

// GetApiVersion returns the ApiVersion field value if set, zero value otherwise.
func (o *SalesforceControllerActionObjectRequest) GetApiVersion() string {
	if o == nil || IsNil(o.ApiVersion) {
		var ret string
		return ret
	}
	return *o.ApiVersion
}

// GetApiVersionOk returns a tuple with the ApiVersion field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SalesforceControllerActionObjectRequest) GetApiVersionOk() (*string, bool) {
	if o == nil || IsNil(o.ApiVersion) {
		return nil, false
	}
	return o.ApiVersion, true
}

// HasApiVersion returns a boolean if a field has been set.
func (o *SalesforceControllerActionObjectRequest) HasApiVersion() bool {
	if o != nil && !IsNil(o.ApiVersion) {
		return true
	}

	return false
}

// SetApiVersion gets a reference to the given string and assigns it to the ApiVersion field.
func (o *SalesforceControllerActionObjectRequest) SetApiVersion(v string) {
	o.ApiVersion = &v
}

func (o SalesforceControllerActionObjectRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SalesforceControllerActionObjectRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	if !IsNil(o.Instance) {
		toSerialize["instance"] = o.Instance
	}
	if !IsNil(o.ApiVersion) {
		toSerialize["apiVersion"] = o.ApiVersion
	}
	return toSerialize, nil
}

type NullableSalesforceControllerActionObjectRequest struct {
	value *SalesforceControllerActionObjectRequest
	isSet bool
}

func (v NullableSalesforceControllerActionObjectRequest) Get() *SalesforceControllerActionObjectRequest {
	return v.value
}

func (v *NullableSalesforceControllerActionObjectRequest) Set(val *SalesforceControllerActionObjectRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableSalesforceControllerActionObjectRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableSalesforceControllerActionObjectRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSalesforceControllerActionObjectRequest(val *SalesforceControllerActionObjectRequest) *NullableSalesforceControllerActionObjectRequest {
	return &NullableSalesforceControllerActionObjectRequest{value: val, isSet: true}
}

func (v NullableSalesforceControllerActionObjectRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSalesforceControllerActionObjectRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
